/**
 * 
 * @author Tom Kelliher
 * A class for creating a modulo counter.  The counter's initial count is 0.
 * When count reaches limit, count resets to 0.  The default value of limit is
 * an integer's maximum value.
 *
 */

public class ModCounter {
	
	public ModCounter() {
		count = 0;
		limit = Integer.MAX_VALUE;
	}

	/**
	 * Return and increment the count.  If count has reached limit, reset
	 * count to 0.
	 * @return The next count.
	 */
	
	public int next() {
		int val = count;
		count = (count + 1) % limit;
		return val;
	}
	
	/**
	 * Set limit.
	 * @param limit The count's limit.
	 */
	
	public void setLimit(int limit) {
		this.limit = limit;
	}
	
	private int count;
	private int limit;
}
